/* За этот код особая благодарность AlexGyver, Его сайту и его проектам !
 * Его канал на Ютубчике  https://youtu.be/O7r3XKO9aeo 
 * Офф сайт https://AlexGyver.ru/
 * 
 * Это не итоговый код. Далее хочу усложнить переключение режимов и т.п. По этому выкладываю как есть...
 * Меня можно найти тут http://forum.amperka.ru/members/securbond.8768/ 
 */
#include "fonts.h"
#include "FastLED.h"
#include "GyverTimer.h"
#include "BluetoothSerial.h"
#include <WiFi.h>
#include <PubSubClient.h>

#if !defined(CONFIG_BT_ENABLED) || !defined(CONFIG_BLUEDROID_ENABLED)
#error Bluetooth is not enabled! Please run `make menuconfig` to and enable it
#endif

#define LED_PIN 14          // пин ленты D14 ESP32
#define BRIGHTNESS 30       // стандартная маскимальная яркость (0-255)
#define WIDTH 16            // ширина матрицы
#define HEIGHT 16           // высота матрицы

//****Для парсинга******
#define PARSE_AMOUNT 4    // максимальное количество значений в массиве, который хотим получить
#define header '$'        // стартовый символ
#define divider ' '       // разделительный символ
#define ending ';'        // завершающий символ
byte intData[PARSE_AMOUNT];     // массив численных значений после парсинга
char incomingByte;
String parsingText = "";
boolean parseStarted;
boolean FlagPars;
//**************************************************

#define MATRIX_TYPE 0       // тип матрицы: 0 - зигзаг, 1 - последовательная
#define CONNECTION_ANGLE 3  // угол подключения: 0 - левый нижний, 1 - левый верхний, 2 - правый верхний, 3 - правый нижний
#define STRIP_DIRECTION 1   // направление ленты из угла: 0 - вправо, 1 - вверх, 2 - влево, 3 - вниз
#define NUM_LEDS WIDTH * HEIGHT
CRGB leds[NUM_LEDS]; 

IPAddress LOCAL_IP_ADR;
uint32_t prevColor;
boolean recievedFlag;

byte prevY = 0;
byte prevX = 0;

String date;
int h,m,s;
int sunrise, sunset;
char time_message[50];
char ip_message[21];

char date_message[50];

boolean runningFlag ;
boolean loadingFlag ;
boolean textFlag;
boolean effectsFlag;
boolean messFlag;

int rejim; 
byte effect;
byte globalBrightness = BRIGHTNESS;
byte globalSpeed = 100;
uint32_t globalColor = 0x00ff00;   // цвет при запуске зелёный
byte breathBrightness;
int speedEffect = 110;
   // Таймеры //
GTimer_ms getMyTime(1800000); //30 минут интервал обновления времени с сервера. Матрица при этом ненадолго подвисает.
GTimer_ms effectTimer(speedEffect); // скорость эффектов
GTimer_ms textTimer(9000); // ограничение частоты вывода текста на матрицу
GTimer_ms scrollTimer(100); // скорость сдвига прокрутки текста

const char* ssid = "VasyaPupkin"; // имя wifi SSID (name)
const char* password = "12345678"; // пароль wifi

   //**Данные для сервера MQTT**// 
const char* mqtt_server = "192.168.0.106";//Адрес сервера MQTT
unsigned int mqtt_port = 1883;
const char* mqtt_name = "Matrix2";
const char* mqtt_user = ""; // логин если нужен
const char* mqtt_pass = "1"; // пароль
const char* mqtt_sub_inform = "/pogoda/sensors/tempDS";//Топик в котором находится температура на улице
const char* mqtt_sub_mess = "/matrix2/mess";//Сообщение на матрицу
const char* mqtt_sub_rejim = "/matrix2/rejim";//Режим работы
const char* mqtt_sub_parsing = "/matrix2/parsing";// парсинг из MQTT Пока не работает!!
const char* mqtt_pub_inform = "/matrix2/OutMes";
const char* mqtt_pub_time = "/matrix2/Time"; //Топик для публикации времени в esp

WiFiClient ESPclient;
PubSubClient MQTTclient(ESPclient);
BluetoothSerial SerialBT;

char TempStr[10]; //Переменная для хранения строки температуры, для вывода на матрицу
String txtMessage = "xxx-xxx"; //хранения текста выводимого на матрицу в данный момент
String txtInfo = ""; //для получения данных из топика
String temp_message = ""; //хранение температуры
String matrix_message = ""; //хранение текста из топика
String runningText = ""; //хранение текста из топика

void setup() {
  Serial.begin(115200);
  SerialBT.begin("ESP32test"); //Bluetooth device name
  // настройки ленты
  FastLED.addLeds<WS2812, LED_PIN, GRB>(leds, NUM_LEDS).setCorrection( TypicalLEDStrip );
  FastLED.setBrightness(globalBrightness);
  FastLED.clear();
  FastLED.show();
  randomSeed(analogRead(0) + analogRead(1));    // пинаем генератор случайных чисел
  setup_wifi(); //Подключаемся к WiFi  
  getTime(); //получаем точное время
  rejim = 1;   // Режим по умолчанию
  
    // *********** MQTT client *********************
  // Подключение к брокеру //
  MQTTclient.setServer(mqtt_server, mqtt_port);
  MQTTclient.setCallback(callback);
  MQTTclient.connect(mqtt_name); 
  // Подписываемся на нужные топики //
  MQTTclient.subscribe(mqtt_sub_inform);
  MQTTclient.subscribe(mqtt_sub_mess);
  MQTTclient.subscribe(mqtt_sub_rejim);
  MQTTclient.subscribe(mqtt_sub_parsing);  
}

void setup_wifi() { //функция подключения к WiFi 
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.persistent(false);
  WiFi.mode(WIFI_OFF);  
  WiFi.begin(ssid, password);
  WiFi.setAutoReconnect(true);  //automatically reconnects to hwAP in case it is disconnected
  int i = 0;
  while (WiFi.status() != WL_CONNECTED && i < 15) {  
    delay(500);
    i++;
    Serial.print(".");
  }
  Serial.println();
  Serial.println(" WiFi connected");
  Serial.print("IP address: ");  

    String runningText = (WiFi.localIP().toString());  // IP to String
    int ip_len = runningText.length() + 1; 
    runningText.toCharArray(ip_message, ip_len) ;// IP String to Char 
    Serial.println(ip_message);  
} 

void callback(char* topic, byte* payload, unsigned int length) {//callback MQTT  
  int txtInfoLen; //длинна сообщения топика
  /*     if(String(topic) == mqtt_sub_parsing) { //Если пришла информация из для парсинга     
     txtInfo = "";
     txtInfoLen =  length;     
    for (int i = 0; i < length; i++) {                                                
       incomingByte = (payload[i]);  
    } 
    }
 */   
     if(String(topic) == mqtt_sub_inform) { //Если пришла информация из топика с температурой
     txtInfoLen =  length;
     txtInfo = ""; 
    for (int i = 0; i < length; i++) {                                               
       txtInfo += ((char)payload[i]);   
    } 
       txtInfo.toCharArray(TempStr, 10);  // копируем 10 символов в массив TempStr   
       float temp = atof(TempStr);
       txtInfo = (String(temp,1)+"\x60"+"C"); //Добавляем к температуре  "°С" (в сериал выводит квадратик)   
       temp_message = txtInfo;   
    }
     if(String(topic) == mqtt_sub_mess) {   //Если пришла информация из топика с текстом
          txtInfo = ""; 
    for (int i = 0; i < length; i++) {                                               
       txtInfo += ((char)payload[i]);
       if (txtInfo != matrix_message){
       matrix_message = txtInfo;
       rejim = 6;  //сразу пускаем текст на матрицу 6 режим      
    }        
}
     }
     if(String(topic) == mqtt_sub_rejim) {  //Если пришла информация из топика с режимом работы
          txtInfo = ""; 
          if (length > 1){
       Serial.println("Не верный формат режима"); 
          }else{          
    for (int i = 0; i < length; i++) {                                               
       txtInfo += ((char)payload[i]);
       rejim = (txtInfo.toInt());  
       Serial.println(rejim);
       if (rejim == 4){
         runningFlag = true ; // еще не разбирался с чужими (AlexGyver) кусками кода, но без этого
         loadingFlag = true;  //  анимация шариков не работает
       }
    }
  }        
}
}

void reconnect(){//функция реконнекта к серверу MQTT
  if(!ESPclient.connected() && WiFi.status() == WL_CONNECTED) {
    Serial.print("Attempting MQTT connection...");
    if(MQTTclient.connect(mqtt_name, mqtt_user, mqtt_pass)) {
      Serial.println("connected");
      MQTTclient.publish(mqtt_pub_inform, ip_message);
      MQTTclient.subscribe(mqtt_sub_inform);
      MQTTclient.subscribe(mqtt_sub_mess);
      MQTTclient.subscribe(mqtt_sub_rejim);
      MQTTclient.subscribe(mqtt_sub_parsing);
    } else {
      Serial.print("failed, rc= ");
      Serial.println(MQTTclient.state());
      delay(1000);
      ESP.restart(); //Если не удалось подключиться к MQTTht,ребутимся через 1 сек. (костыль, потому что я рукожоп)
    }
  }
}

// функции для работы с лентой
// **************** НАСТРОЙКА МАТРИЦЫ ****************

// Gamma коррекция (Defalt Gamma = 2.8)
const uint8_t PROGMEM gammaR[] = {
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,
  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  2,  2,  2,  2,  2,
  2,  2,  2,  3,  3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  4,  5,
  5,  5,  5,  5,  6,  6,  6,  6,  7,  7,  7,  7,  8,  8,  8,  9,
  9,  9, 10, 10, 10, 11, 11, 11, 12, 12, 12, 13, 13, 14, 14, 14,
  15, 15, 16, 16, 17, 17, 18, 18, 19, 19, 20, 20, 21, 21, 22, 22,
  23, 24, 24, 25, 25, 26, 27, 27, 28, 29, 29, 30, 31, 31, 32, 33,
  33, 34, 35, 36, 36, 37, 38, 39, 40, 40, 41, 42, 43, 44, 45, 46,
  46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61,
  62, 63, 65, 66, 67, 68, 69, 70, 71, 73, 74, 75, 76, 78, 79, 80,
  81, 83, 84, 85, 87, 88, 89, 91, 92, 94, 95, 97, 98, 99, 101, 102,
  104, 105, 107, 109, 110, 112, 113, 115, 116, 118, 120, 121, 123, 125, 127, 128,
  130, 132, 134, 135, 137, 139, 141, 143, 145, 146, 148, 150, 152, 154, 156, 158,
  160, 162, 164, 166, 168, 170, 172, 174, 177, 179, 181, 183, 185, 187, 190, 192,
  194, 196, 199, 201, 203, 206, 208, 210, 213, 215, 218, 220, 223, 225, 227, 230
};

const uint8_t PROGMEM gammaG[] = {
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,  1,  1,  1,
  1,  1,  1,  1,  1,  1,  1,  1,  1,  2,  2,  2,  2,  2,  2,  2,
  2,  3,  3,  3,  3,  3,  3,  3,  4,  4,  4,  4,  4,  5,  5,  5,
  5,  6,  6,  6,  6,  7,  7,  7,  7,  8,  8,  8,  9,  9,  9, 10,
  10, 10, 11, 11, 11, 12, 12, 13, 13, 13, 14, 14, 15, 15, 16, 16,
  17, 17, 18, 18, 19, 19, 20, 20, 21, 21, 22, 22, 23, 24, 24, 25,
  25, 26, 27, 27, 28, 29, 29, 30, 31, 32, 32, 33, 34, 35, 35, 36,
  37, 38, 39, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 50,
  51, 52, 54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 66, 67, 68,
  69, 70, 72, 73, 74, 75, 77, 78, 79, 81, 82, 83, 85, 86, 87, 89,
  90, 92, 93, 95, 96, 98, 99, 101, 102, 104, 105, 107, 109, 110, 112, 114,
  115, 117, 119, 120, 122, 124, 126, 127, 129, 131, 133, 135, 137, 138, 140, 142,
  144, 146, 148, 150, 152, 154, 156, 158, 160, 162, 164, 167, 169, 171, 173, 175,
  177, 180, 182, 184, 186, 189, 191, 193, 196, 198, 200, 203, 205, 208, 210, 213,
  215, 218, 220, 223, 225, 228, 231, 233, 236, 239, 241, 244, 247, 249, 252, 255
};

const uint8_t PROGMEM gammaB[] = {
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,
  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  1,
  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  1,  2,  2,  2,
  2,  2,  2,  2,  2,  2,  3,  3,  3,  3,  3,  3,  3,  4,  4,  4,
  4,  4,  5,  5,  5,  5,  5,  6,  6,  6,  6,  6,  7,  7,  7,  8,
  8,  8,  8,  9,  9,  9, 10, 10, 10, 10, 11, 11, 12, 12, 12, 13,
  13, 13, 14, 14, 15, 15, 15, 16, 16, 17, 17, 18, 18, 19, 19, 19,
  20, 20, 21, 22, 22, 23, 23, 24, 24, 25, 25, 26, 27, 27, 28, 28,
  29, 30, 30, 31, 32, 32, 33, 34, 34, 35, 36, 37, 37, 38, 39, 40,
  40, 41, 42, 43, 44, 44, 45, 46, 47, 48, 49, 50, 51, 51, 52, 53,
  54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 69, 70,
  71, 72, 73, 74, 75, 77, 78, 79, 80, 81, 83, 84, 85, 86, 88, 89,
  90, 92, 93, 94, 96, 97, 98, 100, 101, 103, 104, 106, 107, 109, 110, 112,
  113, 115, 116, 118, 119, 121, 122, 124, 126, 127, 129, 131, 132, 134, 136, 137,
  139, 141, 143, 144, 146, 148, 150, 152, 153, 155, 157, 159, 161, 163, 165, 167,
  169, 171, 173, 175, 177, 179, 181, 183, 185, 187, 189, 191, 193, 196, 198, 200
};

// ------------- СЛУЖЕБНЫЕ ФУНКЦИИ --------------

// гамма-коррекция (более натуральные цвета)
uint32_t gammaCorrection(uint32_t color) {
  byte r = (color >> 16) & 0xFF;  // Extract the RR byte
  byte g = (color >> 8) & 0xFF;   // Extract the GG byte
  byte b = color & 0xFF;        // Extract the BB byte

  r = pgm_read_byte(&gammaR[r]);
  g = pgm_read_byte(&gammaG[g]);
  b = pgm_read_byte(&gammaB[b]);

  uint32_t newColor = ((long)(r & 0xff) << 16) + ((long)(g & 0xff) << 8) + ((long)b & 0xff);
  return newColor;
}

// залить все
void fillAll(uint32_t color) {
  for (int i = 0; i < NUM_LEDS; i++) {
    leds[i] = color;
  }
}

// функция отрисовки точки по координатам X Y
void drawPixelXY(int8_t x, int8_t y, uint32_t color) {
  if (x < 0 || x > WIDTH - 1 || y < 0 || y > HEIGHT - 1) return;
  leds[getPixelNumber(x, y)] = color;
}

// функция получения цвета пикселя по его номеру
uint32_t getPixColor(int thisPixel) {
  return (((uint32_t)leds[thisPixel].r << 16) | ((long)leds[thisPixel].g << 8 ) | (long)leds[thisPixel].b);
}

// функция получения цвета пикселя в матрице по его координатам
uint32_t getPixColorXY(byte x, byte y) {
  //if (x < 0 || x > WIDTH - 1 || y < 0 || y > HEIGHT - 1) return;
  return getPixColor(getPixelNumber(x, y));
}

// получить номер пикселя в ленте по координатам
#if (CONNECTION_ANGLE == 0 && STRIP_DIRECTION == 0)
#define _WIDTH WIDTH
#define THIS_X x
#define THIS_Y y

#elif (CONNECTION_ANGLE == 0 && STRIP_DIRECTION == 1)
#define _WIDTH HEIGHT
#define THIS_X y
#define THIS_Y x

#elif (CONNECTION_ANGLE == 1 && STRIP_DIRECTION == 0)
#define _WIDTH WIDTH
#define THIS_X x
#define THIS_Y (HEIGHT - y - 1)

#elif (CONNECTION_ANGLE == 1 && STRIP_DIRECTION == 3)
#define _WIDTH HEIGHT
#define THIS_X (HEIGHT - y - 1)
#define THIS_Y x

#elif (CONNECTION_ANGLE == 2 && STRIP_DIRECTION == 2)
#define _WIDTH WIDTH
#define THIS_X (WIDTH - x - 1)
#define THIS_Y (HEIGHT - y - 1)

#elif (CONNECTION_ANGLE == 2 && STRIP_DIRECTION == 3)
#define _WIDTH HEIGHT
#define THIS_X (HEIGHT - y - 1)
#define THIS_Y (WIDTH - x - 1)

#elif (CONNECTION_ANGLE == 3 && STRIP_DIRECTION == 2)
#define _WIDTH WIDTH
#define THIS_X (WIDTH - x - 1)
#define THIS_Y y

#elif (CONNECTION_ANGLE == 3 && STRIP_DIRECTION == 1)
#define _WIDTH HEIGHT
#define THIS_X y
#define THIS_Y (WIDTH - x - 1)

#else
#define _WIDTH WIDTH
#define THIS_X x
#define THIS_Y y
#pragma message "Wrong matrix parameters! Set to default"

#endif

uint16_t getPixelNumber(byte x, byte y) {
  if ((THIS_Y % 2 == 0) || MATRIX_TYPE) {               // если чётная строка
    return (THIS_Y * _WIDTH + THIS_X);
  } else {                                              // если нечётная строка
    return (THIS_Y * _WIDTH + _WIDTH - THIS_X - 1);
  }
}
  
void loop() { 
parsing(); 
if (!parseStarted) {
if (!MQTTclient.connected()) { // проверяем подключение к MQTT
    reconnect();
  } 
MQTTclient.loop();
if (getMyTime.isReady())  { //Коррректировка времени каждые 30 мин
getTime(); 
}

switch (rejim) {
case 1: // Время  Температура
   globalSpeed = 100;
  if (messFlag == false){
  globalColor = 0x00ff00; //Зеленый
  txtMessage = time_message; //Пишем текущее время в переменную txtMessage
} else {
  globalColor = 0x00CED1; //Голубой
  txtMessage = temp_message; //Пишем текущую температуру в переменную txtMessage
}
if (textTimer.isReady())  { //Пришло время, разрешаем вывод текста на матрицу
  textFlag = true;
  showTime();
  Serial.print ("Температура: ");
  Serial.println (temp_message);
}
if (textFlag){ 
fillString(txtMessage);
}
 break;
 
case 2: // Камин
  globalSpeed = 70;
   if (effectTimer.isReady()) {
   fireRoutine();
   FastLED.show();
}
 break;
 
case 3: // Матрица
  globalSpeed = 120;
   if (effectTimer.isReady()) {
   matrixRoutine();
   FastLED.show();
}
 break;
 
case 4:// Шарики 
   globalSpeed = 70;
   if (effectTimer.isReady()) {    
   ballsRoutine();
   FastLED.show();
}
 break;
 
case 5: // Снег
  globalSpeed = 150;
   if (effectTimer.isReady()) {
   snowRoutine();
   FastLED.show();
}
 break;
 
case 6:  // Текст на матрицу 
  globalSpeed = 100; 
  globalColor = 0x0000CD;
  txtMessage = matrix_message;
if (textTimer.isReady())  { //Пришло время, разрешаем вывод текста на матрицу
  textFlag = true;
  Serial.print ("Текст: ");
  Serial.println (matrix_message);
}
if (textFlag){ 
fillString(txtMessage);
}
 break; 
}

updateTime(); //обновление локальных часов
}
}
byte index1;
String string_convert = "";
enum modes {NORMAL, COLOR, TEXT} parseMode;
void parsing() {
  
  // ****************** ОБРАБОТКА *****************
  /*
    Протокол связи, посылка начинается с режима. Режимы:
    0 - отправка цвета $0 colorHEX;
    1 - отправка координат точки $1 X Y;
    2 - заливка - $2;
    3 - очистка - $3;
    4 - яркость - $4 value;
    5 - картинка $5 colorHEX X Y;
    6 - текст $6 some text
    7 - управление текстом: $7 1; пуск, $7 0; стоп
    8 - режим 
      - $8 0 номерЭффекта;
      - $8 1 старт/стоп;
    9 - игра
    10 - кнопка вверх
    11 - кнопка вправо
    12 - кнопка вниз
    13 - кнопка влево
    14 - пауза в игре
    15 - скорость $8 скорость;
  */
  if (recievedFlag) {      // если получены данные
    recievedFlag = false;

    switch (intData[0]) {
      case 1:
      Serial.println("Case1");
      Serial.print("Data1: ");
      Serial.println(intData[1]);
      Serial.print("Data2: ");
      Serial.println(intData[2]);
        break;
        
      case 2:
      Serial.println("Case2");
      Serial.print("Color: ");
      Serial.println(globalColor);
        break;
        
      case 3:
      Serial.println("Case3");
        break;
        
      case 4:
      Serial.println("Case4");
      Serial.print("Brightnes: ");
      globalBrightness = intData[1];
      Serial.println(globalBrightness);
        break;
        
      case 5:
        Serial.println("Case5");
        break;
        
      case 6:
       Serial.println("Case6");
       Serial.print("Text: ");
       Serial.println(parsingText);
       break;
        
      case 7:
        Serial.println("Case7");
        Serial.print("RunText: ");
        Serial.println(intData[1]);
       
        if (intData[1] == 1) {
          runningFlag = true;
          Serial.print("Status True");
        }                      
        if (intData[1] == 0){
          runningFlag = false;
          Serial.print("Status False");
        }
                
        break;
        
      case 8:
        Serial.println("Case8");
        Serial.print("Rejim; ");
        Serial.println(intData[2]);
        if (intData[1] == 0) {          
          rejim = intData[2];
        if (rejim == 4){
            FastLED.clear();
            runningFlag = true;  // еще не разбирался с чужими (AlexGyver) кусками кода, но без этого
            loadingFlag = true;  //  анимация шариков не работает
           }
        }
        else if (intData[1] == 1) Serial.println("OFF");
        break;
        
   /*   
       case 9:
        loadingFlag = true;
        effectsFlag = false;
        gameFlag = true;
        game = intData[1];
        globalSpeed = intData[2];
        gameTimer.setInterval(globalSpeed * 4);
        break;
      case 10:
        buttons[0] = 1;
        break;
      case 11:
        buttons[1] = 1;
        break;
      case 12:
        buttons[2] = 1;
        break;
      case 13:
        buttons[3] = 1;
        break;
      case 14:
        gameFlag = !gameFlag;
        break;
      case 15: globalSpeed = intData[1];
        if (gameFlag) gameTimer.setInterval(globalSpeed * 4);   // для игр скорость нужно меньше!
        if (effectsFlag) effectTimer.setInterval(globalSpeed);
        if (runningFlag) scrollTimer.setInterval(globalSpeed);
        break;
       */ 
    }
  }

  // ****************** ПАРСИНГ *****************
  if ((SerialBT.available() > 0) || FlagPars == true){
 //   char incomingByte;
    if (parseMode == TEXT) {     // если нужно принять строку
      parsingText = SerialBT.readString();  // принимаем всю
      incomingByte = ending;              // сразу завершаем парс
      parseMode = NORMAL;
    } else if (FlagPars != true) {
      incomingByte = SerialBT.read();        // обязательно ЧИТАЕМ входящий символ
    }
    if (parseStarted) {                         // если приняли начальный символ (парсинг разрешён)
      if (incomingByte != divider && incomingByte != ending) {   // если это не пробел И не конец
        string_convert += incomingByte;       // складываем в строку
      } else {                                // если это пробел или ; конец пакета
        if (index1 == 0) {
          byte thisMode = string_convert.toInt();
          if (thisMode == 0 || thisMode == 5) parseMode = COLOR;    // передача цвета (в отдельную переменную)
          else if (thisMode == 6) parseMode = TEXT;
          else parseMode = NORMAL;
          //if (thisMode != 7 || thisMode != 0) runningFlag = false;
        }

        if (index1 == 1) {       // для второго (с нуля) символа в посылке
          if (parseMode == NORMAL) intData[index1] = string_convert.toInt();             // преобразуем строку в int и кладём в массив}
          if (parseMode == COLOR) globalColor = strtol(&string_convert[0], NULL, 16);    // преобразуем строку HEX в цифру
        } else {
          intData[index1] = string_convert.toInt();  // преобразуем строку в int и кладём в массив
        }
        string_convert = "";                  // очищаем строку
        index1++;                              // переходим к парсингу следующего элемента массива
      }
    }
    if (incomingByte == header) {             // если это $
      parseStarted = true;                      // поднимаем флаг, что можно парсить
      index1 = 0;                              // сбрасываем индекс
      string_convert = "";                    // очищаем строку
    }
    if (incomingByte == ending) {             // если таки приняли ; - конец парсинга
      parseMode == NORMAL;
      parseStarted = false;                     // сброс
      recievedFlag = true;                    // флаг на принятие
    }
  }
}

float utcOffset = 3; //часовой пояс
long localEpoc = 0;
long localMillisAtUpdate = 0;

// =======================================================================
void updateTime(){ //Функция локальных часов
  long curEpoch = localEpoc + ((millis() - localMillisAtUpdate) / 1000);
  long epoch = (int) round(curEpoch + 3600 * utcOffset + 86400L) % 86400L;
  h = ((epoch  % 86400L) / 3600) % 24;
  m = (epoch % 3600) / 60;
  s = epoch % 60;
}
void getTime(){ //Функция получения времени с гугла
  
  WiFiClient client;
  if (!client.connect("www.google.com", 80)) {
    Serial.println("connection to google failed");
    return;
  }
  client.print(String("GET / HTTP/1.1\r\n") +
               String("Host: www.google.com\r\n") +
               String("Connection: close\r\n\r\n"));
  int repeatCounter = 0;
  while (!client.available() && repeatCounter < 10) {
    delay(300);
    //Serial.println(".");
    repeatCounter++;
  }
  String line;
  client.setNoDelay(false);
  while(client.connected() && client.available()) {
    line = client.readStringUntil('\n');
    line.toUpperCase();
    if (line.startsWith("DATE: ")) {
      date = ""+line.substring(6, 22);
      h = line.substring(23, 25).toInt();
      m = line.substring(26, 28).toInt();
      s = line.substring(29, 31).toInt();
      localMillisAtUpdate = millis();
      localEpoc = (h * 60 * 60 + m * 60 + s); //запись времени в локальную переменную
      String clock_date = date;
      Serial.print("Дата: ");
      Serial.println(clock_date);
      int date_len = clock_date.length() + 1; 
      clock_date.toCharArray(date_message, date_len) ;    
    }
  }
  client.stop();
}
void showTime(){ //Формирование строки времени
    String timeString = "";
    timeString+= h/10 ? h/10 : 0;
    timeString+= h%10;
    timeString+= ":";
    timeString+= m/10;
    timeString+= m%10;
  //  timeString+= ":"; //Можно раскомментировать три строчки, если нужны секунды
  //  timeString+= s/10;
  //  timeString+= s%10;   
    String clock_time = timeString;
    int clock_len = clock_time.length() + 1; 
    clock_time.toCharArray(time_message, clock_len) ;// Сохраняем время в массив - time_message
    
    Serial.print("Время: ");
    MQTTclient.publish(mqtt_pub_time, time_message); //Публикуем время в топик для контроля
    Serial.println(time_message);
}


